const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const integrations = sequelize.define(
    'integrations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

provider: {
        type: DataTypes.ENUM,
      
      

        values: [

"google_calendar",


"smtp",


"sendgrid",


"mailgun",


"other"

        ],

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"connected",


"disconnected",


"error"

        ],

      },

config_json: {
        type: DataTypes.TEXT,
      
      

      },

connected_at: {
        type: DataTypes.DATE,
      
      

      },

last_sync_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  integrations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























    db.integrations.hasMany(db.calendar_accounts, {
      as: 'calendar_accounts_integration',
      foreignKey: {
          name: 'integrationId',
      },
      constraints: false,
    });





//end loop



    db.integrations.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.integrations.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.integrations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.integrations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return integrations;
};


